/******************************************************************************/
/* motor.h		                                                              */
/*                                                                            */
/* This is proprietary information, not to be published -- DIGIPRO DATA   	  */
/* Copyright (C) 2002, DigiPro Information Co.,Ltd.  All Rights Reserved.     */ 
/* MACRO FUNCTIONS:                                                           */
/*	  change_count 	 change  turned forward/backward  					  	  */
/*	  set_step_motor Sets step_motor										  */
/*	  set_DC_motor	 Sets DC_motor											  */
/* FUNCTIONS:                                                                 */ 
/*	  driver_motor	 control/init Step motor and DC motor					  */			
/* GLOBAL VARIABLES:                                                          */
/*                                                                            */
/* Author: Wu DingMing                                                        */
/* Date: August 12, 2002                                                      */
/******************************************************************************/
#define	INIT_STEP_MOTOR_LIST		{0x0A,0x09,0x05,0x06} 
									/*           [DCBA]						  */
									/* 0  --0b00001010				  		  */		
									/* 90 --0b00001001			 			  */
									/* 180--0b00000101						  */
									/* 270--0b00000110						  */
									
#define	INIT_MOTOR_STATE         	0xF0
#define	STEP_MOTOR_STOP_STATE       0x0F
#define	DC_MOTOR_STOP_STATE       	0

#define	DC_MOTOR					0
#define	STEP_MOTOR					1
#define	INIT_DC_MOTOR				2
#define	INIT_STEP_MOTOR				3

#define	change_count(val,state)		val = (state -1) ? ((val+1)&0x3) : ((val-1)&0x3) 
#define	set_step_motor(val,state)  	val = (val & 0xFF0F) | ((state & 0x000F)<<4)
#define	set_DC_motor(val,state)  	val = (val & 0xFFFC) | (state & 0x0003)

void driver_motor(unsigned int motor,unsigned int state,unsigned int delay);
