/******************************************************************************/
/* LCD.h		                                                              */
/*                                                                            */
/* This is proprietary information, not to be published -- DIGIPRO DATA   	  */
/* Copyright (C) 2002, DigiPro Information Co.,Ltd.  All Rights Reserved.     */ 
/* MACRO FUNCTIONS:                                                           */
/*	  wr_lcd_data	 write lcd data											  */
/*	  wr_lcd_cmd	 write lcd cmd											  */
/*	  rd_lcd_data	 read lcd data											  */
/*	  LCD_home	 	 set location to home(0,0)								  */
/*	  open_lcd	 	 OPEN LCD												  */
/*	  close_lcd	 	 CLOSE LCD												  */
/* FUNCTIONS:                                                                 */ 
/*	  wr_lcd_serial  write lcd											  	  */
/*	  rd_lcd_serial	 read lcd												  */
/* GLOBAL VARIABLES:                                                          */
/*                                                                            */
/* Author: Wu DingMing                                                        */
/* Date: August 12, 2002                                                      */
/* change by Wu DingMing Data: August 26,2002								  */
/******************************************************************************/
#include "HDdrv.h"
#define wr_lcd_data1(data)		LCDDATA1 = data
#define wr_lcd_cmd1(data)		LCDCMD1 = data
#define wr_lcd_data0(data)		LCDDATA0 = data
#define wr_lcd_cmd0(data)		LCDCMD0 = data         
#define open_lcd1()				wr_lcd_cmd1(0x3F)
#define close_lcd1()			wr_lcd_cmd1(0x3E)
#define open_lcd0()				wr_lcd_cmd0(0x3F)
#define close_lcd0()			wr_lcd_cmd0(0x3E)
#define rd_lcd_data1(data)		data =LCDDATA1
#define lcd_ready1()			while(LCDCMD1&0x80)
#define rd_lcd_data0(data)		data =LCDDATA0
#define lcd_ready0()			while(LCDCMD0&0x80)
#define LCD_home()				LCD_rowcol(0, 0)      

#define MAX_ROW					8
#define MAX_COL					128
#define MAX_ROW_BIT				64
#define MAX_COL_BIT				128

void LCD_disp(unsigned int *buf);
void LCD_clear(unsigned int data);
void LCD_rowcol(unsigned row, unsigned col);
void wr_lcd_serial1(unsigned add,unsigned data);
void wr_lcd_serial0(unsigned add,unsigned data);
void Lcd_writedata(unsigned row, unsigned col,unsigned data);
unsigned int Lcd_readdata(unsigned row, unsigned col);
void init_lcd(void);
