/******************************************************************************/
/* mmdrv.h                                                                    */
/*                                                                            */
/* This is proprietary information, not to be published -- DIGIPRO DATA   	  */
/* Copyright (C) 2002, DigiPro Information Co.,Ltd.  All Rights Reserved.     */
/*                                                                            */
/* Author: Wu DingMing                                                        */
/* Date: August 12, 2002                                                      */
/******************************************************************************/

/******************************************************************************/
/*	CPU Memory-Mapped Registers                                               */
/******************************************************************************/
#define IMR_ADDR        	0x0000
#define IFR_ADDR        	0x0001
#define ST0_ADDR        	0x0006
#define ST1_ADDR        	0x0007
#define AL_ADDR				0x0008
#define AH_ADDR				0x0009
#define AG_ADDR				0x000A
#define BL_ADDR				0x000B
#define BH_ADDR				0x000C
#define BG_ADDR				0x000D
#define T_ADDR				0x000E
#define TRN_ADDR			0x000F
#define AR0_ADDR			0x0010
#define AR1_ADDR			0x0011
#define AR2_ADDR			0x0012
#define AR3_ADDR			0x0013
#define AR4_ADDR			0x0014
#define AR5_ADDR			0x0015
#define AR6_ADDR			0x0016
#define AR7_ADDR			0x0017
#define SP_ADDR				0x0018
#define BK_ADDR				0x0019
#define BRC_ADDR			0x001A
#define RSA_ADDR			0x001B
#define REA_ADDR			0x001C
#define PMST_ADDR			0x001D
#define XPC_ADDR			0x001E

#define IMR             	*(volatile unsigned int *)(IMR_ADDR)
#define IFR             	*(volatile unsigned int *)(IFR_ADDR)
#define ST0             	*(volatile unsigned int *)(ST0_ADDR)
#define ST1             	*(volatile unsigned int *)(ST1_ADDR)
#define AL					*(volatile unsigned int *)(AL_ADDR)
#define AH					*(volatile unsigned int *)(AH_ADDR)
#define AG					*(volatile unsigned int *)(AG_ADDR)
#define BL					*(volatile unsigned int *)(BL_ADDR)
#define BH					*(volatile unsigned int *)(BH_ADDR)
#define BG					*(volatile unsigned int *)(BG_ADDR)
#define T					*(volatile unsigned int *)(T_ADDR)
#define TRN					*(volatile unsigned int *)(TRN_ADDR)
#define AR0					*(volatile unsigned int *)(AR0_ADDR)
#define AR1					*(volatile unsigned int *)(AR1_ADDR)
#define AR2					*(volatile unsigned int *)(AR2_ADDR)
#define AR3					*(volatile unsigned int *)(AR3_ADDR)
#define AR4					*(volatile unsigned int *)(AR4_ADDR)
#define AR5					*(volatile unsigned int *)(AR5_ADDR)
#define AR6					*(volatile unsigned int *)(AR6_ADDR)
#define AR7					*(volatile unsigned int *)(AR7_ADDR)    
#define SP					*(volatile unsigned int *)(SP_ADDR)
#define BK					*(volatile unsigned int *)(BK_ADDR)
#define BRC					*(volatile unsigned int *)(BRC_ADDR)
#define RSA					*(volatile unsigned int *)(RSA_ADDR)
#define REA					*(volatile unsigned int *)(REA_ADDR)
#define PMST				*(volatile unsigned int *)(PMST_ADDR)
#define XPC					*(volatile unsigned int *)(XPC_ADDR) 
/******************************************************************************/
/*	Peripheral Memory-Mapped Registers                                        */
/******************************************************************************/                                                                                
#define TIM_ADDR        	0x0024
#define PRD_ADDR        	0x0025
#define TCR_ADDR        	0x0026
#define SWWSR_ADDR      	0x0028
#define BSCR_ADDR       	0x0029
#define SWCR_ADDR       	0x002b
#define HPIC_ADDR      		0x002c
#define GPIOCR_ADDR 		0x003C                   /* GPIO Control Register */
#define GPIOSR_ADDR 		0x003D                   /* GPIO Status Register */
#define CLKMD_ADDR      	0x0058

#define TIM             	*(volatile unsigned int *)(TIM_ADDR)
#define PRD             	*(volatile unsigned int *)(PRD_ADDR)
#define TCR             	*(volatile unsigned int *)(TCR_ADDR)
#define SWWSR           	*(volatile unsigned int *)(SWWSR_ADDR)
#define BSCR            	*(volatile unsigned int *)(BSCR_ADDR)
#define SWCR            	*(volatile unsigned int *)(SWCR_ADDR)
#define HPIC            	*(volatile unsigned int *)(HPIC_ADDR)
#define GPIOCR          	*(volatile unsigned int *)(GPIOCR_ADDR)
#define GPIOSR          	*(volatile unsigned int *)(GPIOSR_ADDR)
#define CLKMD           	*(volatile unsigned int *)(CLKMD_ADDR)

/******************************************************************************/
/*	DMA Registers					                                          */
/******************************************************************************/
#define DMPREC_ADDR     	0x0054         
#define DMSBAR_ADDR     	0x0055
#define DMSBAI_ADDR     	0x0056
#define DMSBAN_ADDR     	0x0057
#define DMPREC          	*(volatile unsigned int *)(DMPREC_ADDR)
#define DMSBAR          	*(volatile unsigned int *)(DMSBAR_ADDR)
#define DMSBAI          	*(volatile unsigned int *)(DMSBAI_ADDR)
#define DMSBAN          	*(volatile unsigned int *)(DMSBAN_ADDR)
/******************************************************************************/
/*	MCBSP Registers					                                          */
/******************************************************************************/     
#define MCBSP0_DRR2_ADDR	0x20
#define MCBSP0_DRR1_ADDR    0x21
#define MCBSP0_DXR2_ADDR	0x22
#define MCBSP0_DXR1_ADDR    0x23
#define MCBSP0_SPSA_ADDR	0x38
#define MCBSP0_SPAD_ADDR    0x39    
#define MCBSP1_DRR2_ADDR	0x40
#define MCBSP1_DRR1_ADDR    0x41
#define MCBSP1_DXR2_ADDR	0x42
#define MCBSP1_DXR1_ADDR    0x43
#define MCBSP1_SPSA_ADDR	0x48
#define MCBSP1_SPAD_ADDR    0x49
#define MCBSP2_DRR2_ADDR	0x30
#define MCBSP2_DRR1_ADDR    0x31
#define MCBSP2_DXR2_ADDR	0x32
#define MCBSP2_DXR1_ADDR    0x33
#define MCBSP2_SPSA_ADDR	0x34
#define MCBSP2_SPAD_ADDR    0x35
#define MCBSP0_DRR2     	*(volatile unsigned int *)(MCBSP0_DRR2_ADDR)
#define MCBSP0_DRR1     	*(volatile unsigned int *)(MCBSP0_DRR1_ADDR)
#define MCBSP0_DXR2     	*(volatile unsigned int *)(MCBSP0_DXR2_ADDR)
#define MCBSP0_DXR1     	*(volatile unsigned int *)(MCBSP0_DXR1_ADDR)
#define MCBSP0_SPSA     	*(volatile unsigned int *)(MCBSP0_SPSA_ADDR)
#define MCBSP0_SPAD     	*(volatile unsigned int *)(MCBSP0_SPAD_ADDR)
#define MCBSP1_DRR2     	*(volatile unsigned int *)(MCBSP1_DRR2_ADDR)
#define MCBSP1_DRR1     	*(volatile unsigned int *)(MCBSP1_DRR1_ADDR)
#define MCBSP1_DXR2     	*(volatile unsigned int *)(MCBSP1_DXR2_ADDR)
#define MCBSP1_DXR1     	*(volatile unsigned int *)(MCBSP1_DXR1_ADDR)
#define MCBSP1_SPSA     	*(volatile unsigned int *)(MCBSP1_SPSA_ADDR)
#define MCBSP1_SPAD     	*(volatile unsigned int *)(MCBSP1_SPAD_ADDR)
#define MCBSP2_DRR2     	*(volatile unsigned int *)(MCBSP2_DRR2_ADDR)
#define MCBSP2_DRR1     	*(volatile unsigned int *)(MCBSP2_DRR1_ADDR)
#define MCBSP2_DXR2     	*(volatile unsigned int *)(MCBSP2_DXR2_ADDR)
#define MCBSP2_DXR1     	*(volatile unsigned int *)(MCBSP2_DXR1_ADDR)
#define MCBSP2_SPSA     	*(volatile unsigned int *)(MCBSP2_SPSA_ADDR)
#define MCBSP2_SPAD     	*(volatile unsigned int *)(MCBSP2_SPAD_ADDR)

