#include <stdio.h>
#include "mmdrv.h" 
#include "mcbsp.h"  
#include "cpu_reg.h"    
#include "lcd_86.h"  

#define uint16 unsigned int
#define uint8 unsigned char 
 
ioport unsigned portefff;	
#define 	IO_374	 portefff
#define shuzunum 600 



void init_exint1_interrupt();
void init_GPIO(void); 
void uart_rece_gpgga_0(void);  
void uart_rece_gpgga_1(void);
void uart_rece_gprmc_0(void);
void uart_rece_gprmc_1(void);


void uart_trans(void);   
void uart_trans_byte(unsigned int data);

unsigned int flag=0xffff;
char tx_re_buf[1]={0x38};

void display()
{
	  	LCD_clear(0);
	cur_row=0;        
	cur_col=50;        
    LCD_pr_chars("GPGGA",5);
	
		cur_row=1;        
	cur_col=0;        
    LCD_pr_chars("=====================",21);

	cur_row=2;        
	cur_col=0; 
    LCD_pr_chars("K1:H,Tm,WD,JD",13);	

	cur_row=3;        
	cur_col=0; 
    LCD_pr_chars("K2:State,Num,HODP",17);	

	cur_row=4;		  
	cur_col=50; 	   
	LCD_pr_chars("GPRMC",5);

			cur_row=5;        
	cur_col=0;        
    LCD_pr_chars("=====================",21);

	cur_row=6;		  
	cur_col=0; 
	LCD_pr_chars("K3:TM,State,JD,Sd,WD",20);	

	cur_row=7;		  
	cur_col=0; 
	LCD_pr_chars("K4:Azimuth,date,cj,FX",21); 
}
uint16 keyscan()
{
		unsigned int key_val;
		unsigned int i,j;		
		i=Get_Key();
        waitloop( 0x040000L );
		j=Get_Key();

        if(i==j)
        {	
 			key_val=j;		
 			while(Get_Key())
 			 {
 				asm("\tnop"); 
 			 }  
		}
		return key_val;
}




//*************************************************
interrupt void EXINT1_isr()
{
	//flag=0;
	flag=~flag;
	cur_row=5;        
	cur_col=15;       
	init_lcd();
	LCD_clear(0);
   // LCD_pr_chars("Timer_Stop_Count ",17);
   
  	display();
   //		while(!(GPIOSR&0x01))
		 {
				asm("\tnop");
				asm("\tnop");
		 }

}
//**************************************************************
void main(void)
{
 	SWWSR = 0x7fff;
    SWCR = 0x0001;
    BSCR = 0x8006;	  
    CLKMD = PLL_DIV_INIT;
    waitloop( 0x0400 );
    CLKMD = PLL_LOCK_INIT_X(14);	
    waitloop( 0x0400 );        
	PMST = 0x0168;

	IO_374=0xffff;	

	init_exint1_interrupt();
    init_GPIO();   
    init_lcd();

	
	display();  

	
    Close_LED_sign();
    Close_LED_Data(); 
    Close_LED_Traf();
    waitloop( 0x0400 );        
 	while(1)
	{
		flag=0xffff;         
  	  	    switch(keyscan())
	  	     {
	           default: 
	    	    break;
	           case 1:
			   		init_lcd();
   					LCD_clear(0);
					while(flag)
					{
                		uart_rece_gpgga_0();
					};
 	      			break;
			   case 2:
			   		init_lcd();
			   		LCD_clear(0);
					while(flag)
					{
						uart_rece_gpgga_1();
					};
					break;
				case 3:
					init_lcd();
					LCD_clear(0);
					while(flag)
					{
						uart_rece_gprmc_0();
					};
					break;
				case 4:
					init_lcd();
					LCD_clear(0);
					while(flag)
					{
						uart_rece_gprmc_1();
					};
					break;
			   case 17:
			   		init_lcd();
					display();
					break;
              }
         }    
 
}

 
 
/*void init_exint1_interrupt()  
{
	IFR =0xffff;
 	IMR =0x0002;		//0000 0000 0000 0010
	asm("\trsbx\tintm ");
}  */
void init_exint1_interrupt()   
{
	IFR =0xffff;
 	IMR =0x000a;		//TINT=IMR.3	EXINT1=IMR.1	
	asm("\trsbx\tintm ");
}    
 

 
/*interrupt void EXINT1_isr()  
{
    Close_LED_sign();
    Close_LED_Data(); 
    Close_LED_Traf();
//   		while(!(GPIOSR&0x01))
		 {
				asm("\tnop");  
				asm("\tnop");
		 }

//	flag=~flag;
	flag=0;            //?
	cur_row=7;        
	cur_col=15;        
    LCD_pr_chars("    Uart_Stop   ",17);   
}*/

 
 
void init_GPIO(void)   //?
{
	GPIOCR =0xfffe;   
 	GPIOSR =0x0040;		
} 

void uart_rece_gpgga_0(void)   
{   
 	unsigned int ii;
	unsigned int jj;
	unsigned char data[shuzunum];
	unsigned int tm[7],weidu[10],jingdu[11],hb[8],E[2],N[2];
	unsigned int locate=0;
	unsigned int ji_dou=0;
	unsigned int data_num=0;
	char chartable[10]={'0','1','2','3','4','5','6','7','8','9'};
	
	
	Uart_Init(); 
	 
	for(ii=0;ii<shuzunum;ii++)
    {	
    	data[ii] =0;
    } 
	while(1)
	{
		do
		{
			jj = Uart_rx();
	   	    if(!flag) 
		     {
				asm("\tnop");	    	
	    		break;
	    	 }	

		}while(jj==0xFFFF);
	    
	    
	    if(locate<shuzunum)
		{
			data[locate] =jj;
			locate++;
		}
		else
		{	
			ii=0;
		
			while(1)
	        {
	            if(data[ii]==36)//$
	            {  
	            	if((ii+1)<shuzunum&&data[ii+1]==71)//G
	                  if((ii+2)<shuzunum&&data[ii+2]==80)//P
	                    if((ii+3)<shuzunum&&data[ii+3]==71) //G
	                      if((ii+4)<shuzunum&&data[ii+4]==71)//G
	                        if((ii+5)<shuzunum&&data[ii+5]==65)//A
	                           break;
	            }
	            ii++;
	        }
	      
	        
	        ii+=6;
	        for(;ii<shuzunum;ii++)
	        {  
	           if(data[ii]==36)
	           		break; 
	         
	           if(ji_dou==1)
	           {
	           		tm[data_num]=data[ii];
	           		data_num++;
	           }
	           else if(ji_dou==2)
	           {
	           		weidu[data_num]=data[ii];
	           		data_num++;
	           }
	           else if(ji_dou==3)
	           {
	           		N[data_num]=data[ii];
	           		data_num++;
	           }
	           else if(ji_dou==4)
	           {
	           		jingdu[data_num]=data[ii];
	           		data_num++;
	           }
	           else if(ji_dou==5)
	           {
	           		E[data_num]=data[ii];
	           		data_num++;
	           }
	           else if(ji_dou==9)
	           {
	           		hb[data_num]=data[ii];
	           		data_num++;
	           }

	           if(data[ii]==44)
	           {
	           		ji_dou++;
	           		data_num=0;
	           }
	        }

			
		
			cur_col=50;
			cur_row=0;
			LCD_pr_chars("GPGGA",5);

			cur_col=0;
			cur_row=1;
			LCD_pr_chars("***********************",23);
			
			cur_col = 1;
	        cur_row = 2;  
	        LCD_pr_chars("haiba:",6);
            for(ii=0;ii<4;ii++) 
            {
                if(hb[ii]==46)
                	LCD_nextchar('.');
                else   
                	LCD_nextchar(chartable[hb[ii]-48]);
            } 
            
            
            cur_col = 1;
            cur_row =3; 
            LCD_pr_chars("Time:",5);
            LCD_nextchar(chartable[tm[0]-48]);
            LCD_nextchar(chartable[tm[1]-48]);
            LCD_nextchar(':');
            LCD_nextchar(chartable[tm[2]-48]);
            LCD_nextchar(chartable[tm[3]-48]);
            LCD_nextchar(':');
            LCD_nextchar(chartable[tm[4]-48]);
            LCD_nextchar(chartable[tm[5]-48]);
            

            cur_col = 1;
            cur_row = 4; 
            LCD_pr_chars("Latitude:",9);
            
            
            for(ii=0;ii<9;ii++) 
            {
                if(weidu[ii]==46)LCD_nextchar('.');
                else   LCD_nextchar(chartable[weidu[ii]-48]);
            }
			
            if(N[0]==78)LCD_nextchar('N');
            else LCD_nextchar('S');
            
            cur_col = 1;
            cur_row = 5; 
            LCD_pr_chars("Longitude:",10);
            
            
             for(ii=0;ii<9;ii++) 
            {
                if(jingdu[ii]==46)LCD_nextchar('.');
                else   LCD_nextchar(chartable[jingdu[ii]-48]);
            }
			 
            if(E[0]==69)LCD_nextchar('E');
            else LCD_nextchar('W');
			
			cur_row=7;		  
			cur_col=0; 
			LCD_pr_chars("Press <Esc> to Exit",19); 

			
	        break;		
			
		}
	
    }
    	return;	
}

void uart_rece_gpgga_1(void) 
{   
 	unsigned int ii;
	unsigned int jj;
	unsigned char data[shuzunum];
	unsigned int state_gps[2],satellite_num[2],HDOP[4];
	unsigned int locate=0;
	unsigned int ji_dou=0;
	unsigned int data_num=0;
	char chartable[10]={'0','1','2','3','4','5','6','7','8','9'};
	
	
	Uart_Init(); 
	 
	for(ii=0;ii<shuzunum;ii++)
    {	
    	data[ii] =0;
    } 
	while(1)
	{
		do
		{
			jj = Uart_rx();
	   	    if(!flag) 
		     {
				asm("\tnop");	    	
	    		break;
	    	 }	

		}while(jj==0xFFFF);
	  
	    
	    if(locate<shuzunum)
		{
			data[locate] =jj; 
			locate++;
		}
		else
		{	
			ii=0;

			while(1)
	        {
	            if(data[ii]==36)
	            {  
	            	if((ii+1)<shuzunum&&data[ii+1]==71)
	                  if((ii+2)<shuzunum&&data[ii+2]==80)
	                    if((ii+3)<shuzunum&&data[ii+3]==71) 
	                      if((ii+4)<shuzunum&&data[ii+4]==71)
	                        if((ii+5)<shuzunum&&data[ii+5]==65)
	                           break;
	            }
	            ii++;
	        }

	        
	        ii+=6;
	        for(;ii<shuzunum;ii++)
	        {  
	           if(data[ii]==36)
	           		break; 
	         
	           if(ji_dou==6)
	           {
	           		state_gps[data_num]=data[ii];
	           		data_num++;
	           }
	           else if(ji_dou==7)
	           {
	           		satellite_num[data_num]=data[ii];
	           		data_num++;
	           }
	           else if(ji_dou==8)
	           {
	           		HDOP[data_num]=data[ii];
	           		data_num++;
	           }
	           if(data[ii]==44)
	           {
	           		ji_dou++;
	           		data_num=0;
	           }
	        }

			
		
			cur_col=50;
			cur_row=0;
			LCD_pr_chars("GPGGA",5);

			cur_col=0;
			cur_row=1;
			LCD_pr_chars("***********************",23);


            cur_col = 1;
            cur_row = 2; 
            LCD_pr_chars("state_gps:",10);
			cur_col = 1;
            cur_row = 3; 
			if (state_gps[0]=='0')
				LCD_pr_chars("Unlocated",9);
			else if(state_gps[0]=='1')
            	LCD_pr_chars("non-differential gps",20);
			else if(state_gps[0]=='2')
				LCD_pr_chars("differential gps",16);
			else if(state_gps[0]=='6')
				LCD_pr_chars("estimated",9);
				else
				{};

            cur_col = 1;
            cur_row = 4; 
            LCD_pr_chars("satellite_num:",14);
            
            

                if(satellite_num[1]!=0)
				{
						LCD_nextchar(chartable[satellite_num[0]-48]);						
						LCD_nextchar(chartable[satellite_num[1]-48]);
                }
					
                else   
					LCD_nextchar(chartable[satellite_num[0]-48]);




            cur_col = 1;
            cur_row = 5; 
            LCD_pr_chars("HDOP:",5);
            
            
             for(ii=0;ii<4;ii++) 
            {
                if(HDOP[ii]==46)LCD_nextchar('.');
                else   LCD_nextchar(chartable[HDOP[ii]-48]);
            }

			 	cur_row=7;		  
	cur_col=0; 
	LCD_pr_chars("Press <Esc> to Exit",19); 

	        break;		
		}
	
    }
    	return;	
}

void uart_rece_gprmc_0(void)  
{   
 	unsigned int ii;
	unsigned int jj;
	unsigned int data[shuzunum];
	unsigned int time[7],locate_state[2],jingdu[11],speed[6],E[2],N[2],weidu[10];
	unsigned int locate=0;
	unsigned int ji_dou=0;
	unsigned int data_num=0;
	char chartable[10]={'0','1','2','3','4','5','6','7','8','9'};
	
	
	Uart_Init(); 
	 
	for(ii=0;ii<shuzunum;ii++)
    {	
    	data[ii] =0;
    } 
	while(1)
	{
		do
		{
			jj = Uart_rx();
	   	    if(!flag) 
		     {
				asm("\tnop");	    	
	    		break;
	    	 }	

		}while(jj==0xFFFF);
		    
	    
	    if(locate<shuzunum)
		{
			data[locate] =jj; 
			locate++;
		}
		else
		{	
			ii=0;
			while(ii<shuzunum) 
	        {
	            if(data[ii]==36)
	            {  
	            	if((ii+1)<shuzunum&&data[ii+1]==71)
	                  if((ii+2)<shuzunum&&data[ii+2]==80)
	                    if((ii+3)<shuzunum&&data[ii+3]==82) 
	                      if((ii+4)<shuzunum&&data[ii+4]==77)
	                        if((ii+5)<shuzunum&&data[ii+5]==67)
	                           break;
	            }
	            ii++;
	        }

	        
	        ii+=6;
	        for(;ii<shuzunum;ii++)
	        {  
	           if(data[ii]==36)
	           		break; 
	         
	           if(ji_dou==1)
	           {
	           		time[data_num]=data[ii];
	           		data_num++;
	           }
	           else if(ji_dou==2)
	           {
	           		locate_state[data_num]=data[ii];
	           		data_num++;
	           }
			   else if(ji_dou==3)
			   {
			   		weidu[data_num]=data[ii];
					data_num++;
			   }
	           else if(ji_dou==4)//
	           {
	           		N[data_num]=data[ii];
	           		data_num++;
	           }
	           else if(ji_dou==5)
	           {
	           		jingdu[data_num]=data[ii];
	           		data_num++;
	           }
	           else if(ji_dou==6)
	           {
	           		E[data_num]=data[ii];
	           		data_num++;
	           }
	           else if(ji_dou==7)
	           {
	           		speed[data_num]=data[ii];
	           		data_num++;
	           }

	           if(data[ii]==44)
	           {
	           		ji_dou++;
	           		data_num=0;
	           }
	        }

			
				
			cur_col=50;
			cur_row=0;
			LCD_pr_chars("GPRMC",5);

			cur_col=0;
			cur_row=1;
			LCD_pr_chars("***********************",23);
			cur_col = 1;
	        cur_row = 2;  
	        LCD_pr_chars("Locate_State:",13);
            for(ii=0;ii<4;ii++) 
            {
                if(locate_state[ii]==65)
                	LCD_pr_chars("Locate:",6);
                else if(locate_state[ii]==86)  
                	LCD_pr_chars("Unlocate:",8);
                
            } 
            
            
            cur_col = 1;
            cur_row =3; 
            LCD_pr_chars("Time:",5);
            LCD_nextchar(chartable[time[0]-48]);
            LCD_nextchar(chartable[time[1]-48]);
            LCD_nextchar(':');
            LCD_nextchar(chartable[time[2]-48]);
            LCD_nextchar(chartable[time[3]-48]);
            LCD_nextchar(':');
            LCD_nextchar(chartable[time[4]-48]);
            LCD_nextchar(chartable[time[5]-48]);
            

            cur_col = 1;
            cur_row = 4; 
            LCD_pr_chars("Latitude:",9);
            
            
            for(ii=0;ii<9;ii++) 
            {
                if(weidu[ii]==46)
					LCD_nextchar('.');
                else   
					LCD_nextchar(chartable[weidu[ii]-48]);
            }
			
            if(N[0]==78)
				LCD_nextchar('N');
            else 
				LCD_nextchar('S');
            
            cur_col = 1;
            cur_row = 5; 
            LCD_pr_chars("Longitude:",10);
            
            
             for(ii=0;ii<9;ii++) 
            {
                if(jingdu[ii]==46)LCD_nextchar('.');
                else   LCD_nextchar(chartable[jingdu[ii]-48]);
            }
			 
            if(E[0]==69)
				LCD_nextchar('E');
            else 
				LCD_nextchar('W');

            cur_col = 1;
            cur_row = 6; 
            LCD_pr_chars("Speed:",6);
            
            
            for(ii=0;ii<5;ii++) 
            {
                if(speed[ii]==46)
					LCD_nextchar('.');
                else   
					LCD_nextchar(chartable[speed[ii]-48]);
            }

			cur_row=7;		  
			cur_col=0; 
			LCD_pr_chars("Press <Esc> to Exit",19); 

			
	        break;		
			
		}
	
    }
    	return;	
}

void uart_rece_gprmc_1(void)    
{   
 	unsigned int ii;
	unsigned int jj;
	unsigned int data[shuzunum];
	unsigned int azimuth[5],date[7],cipianjiao[5],direction[2];
	unsigned int locate=0;
	unsigned int ji_dou=0;
	unsigned int data_num=0;
	char chartable[10]={'0','1','2','3','4','5','6','7','8','9'};
	Uart_Init(); 
	for(ii=0;ii<shuzunum;ii++)
    {	
    	data[ii] =0;
    } 
	while(1)
	{
		do
		{
			jj = Uart_rx();
	   	    if(!flag) 
		     {
				asm("\tnop");	    	
	    		break;
	    	 }	
		}while(jj==0xFFFF);  
	    if(locate<shuzunum)
		{
			data[locate] =jj; 
			locate++;
		}
		else
		{	
			ii=0;
			while(ii<shuzunum) 
	        {
	            if(data[ii]==36)
	            {  
	            	if((ii+1)<shuzunum&&data[ii+1]==71)
	                  if((ii+2)<shuzunum&&data[ii+2]==80)
	                    if((ii+3)<shuzunum&&data[ii+3]==82) 
	                      if((ii+4)<shuzunum&&data[ii+4]==77)
	                        if((ii+5)<shuzunum&&data[ii+5]==67)
	                           break;
	            }
	            ii++;
	        }
	        
	        ii+=6;
	        for(;ii<shuzunum;ii++)
	        {  
	           if(data[ii]==36)
	           		break; //$
	           if(ji_dou==8)
	           {
	           		azimuth[data_num]=data[ii];
	           		data_num++;
	           }
	           else if(ji_dou==9)
	           {
	           		date[data_num]=data[ii];
	           		data_num++;
	           }
			   else if(ji_dou==10)
			   {
			   		cipianjiao[data_num]=data[ii];
					data_num++;
			   }
	           else if(ji_dou==11)
	           {
	           		direction[data_num]=data[ii];
	           		data_num++;
	           }
	           if(data[ii]==44)
	           {
	           		ji_dou++;
	           		data_num=0;
	           }
	        }
			
			
			
			cur_col=50;
			cur_row=0;
			LCD_pr_chars("GPRMC",5);

			cur_col=0;
			cur_row=1;
			LCD_pr_chars("***********************",23);



	 
		   cur_col = 1;
		   cur_row =2; 
		   LCD_pr_chars("Date:",5);		   
		   LCD_nextchar(chartable[date[4]-48]);
		   LCD_nextchar(chartable[date[5]-48]);

		   LCD_nextchar('-');
		   LCD_nextchar(chartable[date[2]-48]);
		   LCD_nextchar(chartable[date[3]-48]);
		   LCD_nextchar('-');
		   LCD_nextchar(chartable[date[0]-48]);
		   LCD_nextchar(chartable[date[1]-48]);


		   cur_col = 1;
		   cur_row = 3; 
		   LCD_pr_chars("Azimuth:",8);
		   for(ii=0;ii<5;ii++) 
		   {
			   if(azimuth[ii]==46)LCD_nextchar('.');
			   else   LCD_nextchar(chartable[azimuth[ii]-48]);
		   }


		   cur_col = 1;
		   cur_row = 4; 
		   LCD_pr_chars("Cipianjiao:",11);
			for(ii=0;ii<5;ii++) 
		   {
			   if(cipianjiao[ii]==46)LCD_nextchar('.');
			   else   LCD_nextchar(chartable[cipianjiao[ii]-48]);
		   }

            if(direction[0]==87)
				LCD_nextchar('W');
            else 
				LCD_nextchar('E');

				cur_row=7;		  
	cur_col=0; 
	LCD_pr_chars("Press <Esc> to Exit",19); 
			
	        break;		
		}
	
    }
    	return;	
}


