/******************************************************************************/
/* LED.h		                                                              */
/*                                                                            */
/* This is proprietary information, not to be published -- DIGIPRO DATA   	  */
/* Copyright (C) 2002, DigiPro Information Co.,Ltd.  All Rights Reserved.     */ 
/* MACRO FUNCTIONS:                                                           */
/*	  shift_data 	 Sets  in register									  	  */
/*	  shift_traf	 Sets bit in register									  */
/*	  shift_sign	 Sets 2bit in register									  */
/* FUNCTIONS:                                                                 */ 
/*	  Disp_LED_Data	 Disply data led										  */			
/*	  Disp_LED_traf	 Disply traf led										  */			
/*	  Disp_LED_sign	 Disply sign led										  */			
/* GLOBAL VARIABLES:                                                          */
/*                                                                            */
/* Author: Wu DingMing                                                        */
/* Date: August 12, 2002                                                      */
/******************************************************************************/
#define	INIT_LED_DATA_SEG         		0xFF
#define	INIT_LED_DATA_BIT         		0xFF
#define	INIT_LED_TRAF_STATE         	0
#define	INIT_LED_SIGN_STATE    			0

#define	shift_data(bit)			   		~(1<<bit)
#define	shift_traf(val,state,bit)  		val = (val & (~(3<<(bit * 2)))) | ((state & 03)<<(bit * 2))
#define	shift_sign(val,state,bit)  		val = (val & (~(1<<bit))) | ((state & 01)<<bit)      

void Disp_LED_Data(unsigned int encode,unsigned int bit);
void Disp_LED_sign(unsigned int state,unsigned int bit);
void Disp_LED_Traf(unsigned int state,unsigned int bit);
void Close_LED_Data(void);
void Close_LED_Traf(void);
void Close_LED_sign(void);
