/******************************************************************************/
/*main.c                                                   		              */
/*                                                                            */
/* This is proprietary information, not to be published -- DIGIPRO DATA   	  */
/* Copyright (C) 2002, DigiPro Information Co.,Ltd.  All Rights Reserved.     */
/*                                                                            */
/* Author: Wu DingMing & Li Fayue                                             */
/* Date: August 12-28, 2002                                                      */
/******************************************************************************/
#include <stdio.h>
#include "mmdrv.h"
#include "mcbsp.h"
#include "cpu_reg.h"    
#include "lcd_86.h"
 
ioport unsigned portefff;	
#define 	IO_374	 portefff
 
void init_exint1_interrupt();
void init_GPIO(void); 
void uart_rece(void);  
void uart_trans(void);   
void uart_trans_byte(unsigned int data);

unsigned int flag=0xffff;
char tx_re_buf[1]={0x38};
  
void main(void)
{
unsigned int i,j;		
unsigned int key_val;
 
 
 	SWWSR = 0x7fff;
    SWCR = 0x0001;
    BSCR = 0x8006;	  
    CLKMD = PLL_DIV_INIT;
    waitloop( 0x0400 );
    CLKMD = PLL_LOCK_INIT_X(14);	
    waitloop( 0x0400 );        
	PMST = 0x0168;

	IO_374=0xffff;		//374 enable

 	init_exint1_interrupt();
    init_GPIO();   
    init_lcd();
  	LCD_clear(0);
	cur_row=2;        
	cur_col=20;        
    LCD_pr_chars("    UART TEST   ",16);
	cur_row=3;        
	cur_col=1;        
    LCD_pr_chars("-----------------------",23);
    Close_LED_sign();
    Close_LED_Data(); 
    Close_LED_Traf();
    waitloop( 0x0400 );        
 	while(1)
	{
		flag=0xffff;
		i=Get_Key();
        waitloop( 0x040000L );
		j=Get_Key();

        if(i==j)
         {	
 			key_val=j;		/*Save key_val*/
 			while(Get_Key())
 			 {
 				asm("\tnop"); //wait blank_key
 			 }         	 		   	  	    
  	  	    switch(key_val)
	  	     {
	           default: 
	    	    break;
	           case 1:
   				LCD_clear(0);	
                uart_rece();   
 	      		break;
	           case 2:
            	LCD_clear(0);
                uart_trans();   
	      		break;
	           case 3:
		  	  	LCD_clear(0);
 				cur_row=4;        
				cur_col=10;        
			    LCD_pr_chars(" Uart_Trans_Byte=",17);
				tx_re_buf[0]=0x33;
 			    LCD_pr_chars(tx_re_buf,1);
 				uart_trans_byte(3);
   	      		break;
              }
         }    
 	}
}

 
 
void init_exint1_interrupt()   
{
	IFR =0xffff;
 	IMR =0x0002;		//TINT=IMR.3	EXINT1=IMR.1	
	asm("\trsbx\tintm ");
}    

//*************************************************
interrupt void BRINT0_isr()//жϷ
{
	
} 

//*************************************************
interrupt void BXINT0_isr()//жϷ
{
	
}
//*************************************************
interrupt void EXINT1_isr()
{
    Close_LED_sign();
    Close_LED_Data(); 
    Close_LED_Traf();
  		while(!(GPIOSR&0x01))
		 {
				asm("\tnop");
				asm("\tnop");
		 }

	flag=~flag;
	//flag=0;
	cur_row=7;        
	cur_col=15;        
    LCD_pr_chars("    Uart_Stop   ",17);
}

 
 
void init_GPIO(void)   
{
	GPIOCR =0xfffe;   //EXINT1=GPIO.0=input=0,nand_cs=GPIO.6=output=1
 	GPIOSR =0x0040;	  //GPIO.6=output=1			
}    

void uart_rece(void)
{   
	char buf[16];                
	unsigned int data[32];
	unsigned int jj,ii;
	unsigned int locate = 0;
	
	Uart_Init();   
//	Uart_tx(0x00);   
	cur_col = 28;
    cur_row = 1; 
    LCD_pr_chars("UART RECEIVE",12); 
    cur_col = 1;
    cur_row = 2; 
    LCD_pr_chars("=====================",21);  
    for(ii=0;ii<32;ii++)
    {
    	data[ii] =0;
    }
	while(1)
	{

		
		while(1)
		{
			jj = Uart_rx();
	   	    if(!flag) 
		     {
				asm("\tnop");	    	
	    		break;
	    	 }	

		}
		
		if(locate<32)
		{
			data[locate] =jj;       
			cur_col = (locate&7)*16;
	    	cur_row = 3+((locate&24)>>3);       
	    	Unint_to_String(data[locate],16,buf);		
	    	LCD_pr_chars(buf,2);
			locate++;
		}
	    else
	    {
	    	for(ii=0;ii<24;ii++)
	    	{
	    		data[ii] = data[ii+8];
	    	}                         
	    	data[24] = jj;       
	    	for(ii=0;ii<25;ii++)
    		{
    			cur_col = (ii&7)*16;
	    		cur_row = 3+((ii&24)>>3);       
	    		Unint_to_String(data[ii],16,buf);		
	    		LCD_pr_chars(buf,2);
    		}
    		for(;ii<32;ii++)  
    		{                       
    			cur_col = (ii&7)*16;
	    		cur_row = 3+((ii&24)>>3);       	    		
	    		LCD_pr_chars("  ",2);
    		} 
    		locate =25;
	    }                
//	    waitloop(0x800000L);
//		jj= (jj+1)&0xff;
	    Uart_tx(jj); 	    
#if 1	    
   	    if(!flag) 
	    {
			asm("\tnop");	    	
	    	break;
	    }	
#endif
    }	
	return;
}
void uart_trans(void)
{   
	char buf[16];                
	unsigned int data[32];
	unsigned int jj,ii;
	unsigned int locate = 0;
	
	Uart_Init();   
	cur_col = 25;
    cur_row = 1; 
    LCD_pr_chars("UART TRANSFER",13); 
    cur_col = 1;
    cur_row = 2; 
    LCD_pr_chars("=====================",21);  
	jj =0;
    for(ii=0;ii<32;ii++)
    {
    	data[ii] =0;
    }
	while(1)
	{
		
	    Uart_tx(jj); 
		if(locate<32)
		{
			data[locate] =jj;       
			cur_col = (locate&7)*16;
	    	cur_row = 3+((locate&24)>>3);       
	    	Unint_to_String(data[locate],16,buf);		
	    	LCD_pr_chars(buf,2);
			locate++;
		}
	    else
	    {
	    	for(ii=0;ii<24;ii++)
	    	{
	    		data[ii] = data[ii+8];
	    	}                         
	    	data[24] = jj;       
	    	for(ii=0;ii<25;ii++)
    		{
    			cur_col = (ii&7)*16;
	    		cur_row = 3+((ii&24)>>3);       
	    		Unint_to_String(data[ii],16,buf);		
	    		LCD_pr_chars(buf,2);
    		}
    		for(;ii<32;ii++)  
    		{                       
    			cur_col = (ii&7)*16;
	    		cur_row = 3+((ii&24)>>3);       	    		
	    		LCD_pr_chars("  ",2);
    		} 
    		locate =25;
	    }                
	    waitloop(0x800000L);
		jj= (jj+1)&0xff;
	    	    
   	    if(!flag) 
	    {
			asm("\tnop");	    	
	    	break;
	    }	
    }	
	return;
}
 
void uart_trans_byte(unsigned int data)
{   
  	
	Uart_Init();   
  	Uart_tx(data); 
 	    	    
//   	    if(!flag) 
//	    {
//			asm("\tnop");	    	
//	    	break;
//	    }	
//	 }
} 

