/******************************************************************************/
/* LCD_driver.c                                                               */
/*                                                                            */
/* This is proprietary information, not to be published -- DIGIPRO DATA   	  */
/* Copyright (C) 2002, DigiPro Information Co.,Ltd.  All Rights Reserved.     */
/*                                                                            */
/* Author: Wu DingMing                                                        */
/* Date: August 12, 2002                                                      */
/* change by Wu DingMing Data: August 26,2002								  */
/******************************************************************************/
#include "lcd.h"                   
/* -----------------7/15/99 6:53PM-------------------
   wr_lcd_serial: routine to write data & commands to LCD
           input: add (0=cmd, 1=data)
                  data to be sent to the LCD
          action: Output data or command to LCD
          return: void
         remarks: 
--------------------------------------------------*/
void wr_lcd_serial1(unsigned add,unsigned data)
{             
	lcd_ready1();
	if(add)       
		LCDDATA1 = data;
	else               
		LCDCMD1 = data;
	return;
}
void wr_lcd_serial0(unsigned add,unsigned data)
{             
	lcd_ready0();
	if(add)       
		LCDDATA0 = data;
	else               
		LCDCMD0 = data;		
	return;
}
void LCD_rowcol(unsigned row, unsigned col)
{
	if(col>((MAX_COL>>1)-1))
	{
		lcd_ready1();
	    wr_lcd_cmd1(0x0B8 + row);                   	/* Set Page */
	    lcd_ready1();
	    wr_lcd_cmd1(0x040 + col-(MAX_COL>>1));       	/* Set column */
    }
    else
    {    
	    lcd_ready0();
	    wr_lcd_cmd0(0x0B8 + row);                   	/* Set Page */
	    lcd_ready0();
	    wr_lcd_cmd0(0x040 + col);       			   	/* Set column */
    }
    return;
}                                               
void Lcd_writedata(unsigned row, unsigned col,unsigned data)
{
    if(col>((MAX_COL>>1)-1))
	{
		lcd_ready1();
	    wr_lcd_cmd1(0x0B8 + row);                   	/* Set Page */
	    lcd_ready1();
	    wr_lcd_cmd1(0x040 + col-(MAX_COL>>1));       	/* Set column */
	    lcd_ready1();
	    wr_lcd_data1(data&0xff);
    }
    else
    {    
	    lcd_ready0();
	    wr_lcd_cmd0(0x0B8 + row);                   	/* Set Page */
	    lcd_ready0();
	    wr_lcd_cmd0(0x040 + col);       			   	/* Set column */ 
	    lcd_ready0();
	    wr_lcd_data0(data&0xff);
    }
    return;
}
unsigned int Lcd_readdata(unsigned row, unsigned col)
{
	unsigned int data;
	if(col>((MAX_COL>>1)-1))
	{
		lcd_ready1();
	    wr_lcd_cmd1(0x0B8 + row);                   	/* Set Page */
	    lcd_ready1();
	    wr_lcd_cmd1(0x040 + col-(MAX_COL>>1));       			   	/* Set column */ 
	    lcd_ready1();
	    /*data =LCDDATA1;*/
	    rd_lcd_data1(data);
	    lcd_ready1(); 
	    /*data =LCDDATA0;*/
	    rd_lcd_data1(data);
    }
    else
    {    
	    lcd_ready0();
	    wr_lcd_cmd0(0x0B8 + row);                   	/* Set Page */
	    lcd_ready0();
	    wr_lcd_cmd0(0x040 + col);       			   	/* Set column */
	    lcd_ready0();	    
	    /*data =LCDDATA1;*/
	    rd_lcd_data0(data);
	    lcd_ready0(); 
	    /*data =LCDDATA0;*/
	    rd_lcd_data0(data);
    }
    return(data);
}
void LCD_clear(unsigned int data)
{
  int i,j;
  for ( j=0 ;j<MAX_ROW;j++)
  {
    LCD_rowcol(j,0);
    for ( i=0;i<(MAX_COL>>1);i++)
    {
            lcd_ready0();
            wr_lcd_data0(data&0xff);
    }               
    LCD_rowcol(j,(MAX_COL>>1));
    for ( ;i<MAX_COL;i++)
    {
            lcd_ready1();
            wr_lcd_data1(data&0xff);
    }
  }
  LCD_home();
  return;
}
void LCD_disp(unsigned int *buf)
{
	int i,j;
	for ( j=1 ;j<MAX_ROW;j+=2)
	{
		LCD_rowcol(j,0);
		for ( i=0;i<(MAX_COL>>1);i++)
		{                           
			lcd_ready0();
			wr_lcd_data0(buf[j*MAX_COL+i]&0xff);
		}
		LCD_rowcol(j,(MAX_COL>>1));
		for ( ;i<MAX_COL;i++)
		{             
			lcd_ready1();              
			wr_lcd_data1(buf[j*MAX_COL+i]&0xff);
		}
	}
	for ( j=0 ;j<MAX_ROW;j+=2)
	{
		LCD_rowcol(j,0);
		for ( i=0;i<(MAX_COL>>1);i++)
		{                
			lcd_ready0();           
			wr_lcd_data0((buf[j*MAX_COL+i]&0xff00)>>8);
		}
		LCD_rowcol(j,(MAX_COL>>1));
		for ( ;i<MAX_COL;i++)
		{                           
			lcd_ready1();
			wr_lcd_data1((buf[j*MAX_COL+i]&0xff00)>>8);
		}
	}
	LCD_home();
	return;
}                                       
void init_lcd(void)
{
 	lcd_ready0();                           
	wr_lcd_cmd0(0xC0);									/*set start row*/
	lcd_ready1();
	wr_lcd_cmd1(0xC0);									/*set start row*/      
	
 	lcd_ready0();   
	open_lcd0(); 
	lcd_ready1();
	open_lcd1();
 	return;
}
