/******************************************************************************/
/* LED_driver.c                                                               */
/*                                                                            */
/* This is proprietary information, not to be published -- DIGIPRO DATA   	  */
/* Copyright (C) 2002, DigiPro Information Co.,Ltd.  All Rights Reserved.     */
/*                                                                            */
/* Author: Wu DingMing                                                        */
/* Date: August 12, 2002                                                      */
/******************************************************************************/
#include "HDdrv.h"                      
#include "led.h"                             

void Disp_LED_Data(unsigned int encode,unsigned int bit)
{                            
/******************************************************************************/
/*		 A                                                                    */
/*      ___       	[DP,G,F,E,D,C,B,A]                                        */
/*    F|   |B                                                                 */
/*		_G_                                                                   */
/*	  E|   |C                                                                 */
/*		___  .DP                                                              */
/*		 D                                                                    */  
/******************************************************************************/
#if 1
	static unsigned int data[32] ={ 					/*    [ PGFEDCBA]	  */
										0xC0, 			/* 0--0B11000000	  */		
										0xF9, 			/* 1--0B11111001	  */
										0xA4, 			/* 2--0B10100100	  */
										0xB0, 			/* 3--0B10110000	  */
										0x99, 			/* 4--0B10011001  	  */
										0x92, 			/* 5--0B10010010	  */
										0x82, 			/* 6--0B10000010	  */
										0xF8, 			/* 7--0B11111000	  */
										0x80, 			/* 8--0B10000000	  */
										0x90, 			/* 9--0B10010000	  */
										0x88, 			/* A--0B10001000	  */
										0x83, 			/* b--0B10000011	  */
										0xC6, 			/* C--0B11000110	  */
										0xA1, 			/* d--0B10100001	  */
										0x86, 			/* E--0b10000110	  */
										0x8E, 			/* F--0b10001110	  */
										0x80, 			/* 0.--0b01000000	  */		
										0x79, 			/* 1.--0b01111001	  */
										0x24, 			/* 2.--0b00100100	  */
										0x30, 			/* 3.--0b00110000	  */
										0x19, 			/* 4.--0b00011001  	  */
										0x12, 			/* 5.--0b00010010	  */
										0x02, 			/* 6.--0b00000010	  */
										0x78, 			/* 7.--0b01111000	  */
										0x00, 			/* 8.--0b00000000	  */
										0x10, 			/* 9.--0b00010000	  */
										0xC8, 			/* ^ --0b11001000	  */
										0xBF, 			/* - --0b10111111	  */
										0xF7, 			/* _ -- 0b11110111	  */
										0x7F, 			/* . -- 0b01111111	  */
										0xF6, 			/* = -- 0b11110110	  */
										0xFF  			/*   -- 0b11111111	  */
									} ;
#else
	static unsigned int data[32] ={ 					/*    [ PGFEDCBA]	  */
														/*	  [ GFPBACDE]     */
										0xA0, 			/* 0--0B10100000	  */		
										0xEB, 			/* 1--0B11101011	  */
										0x64, 			/* 2--0B01100100	  */
										0x61, 			/* 3--0B01100001	  */
										0x2B, 			/* 4--0B00101011  	  */
										0x31, 			/* 5--0B00110001	  */
										0x30, 			/* 6--0B00110000	  */
										0xE3, 			/* 7--0B11100011	  */
										0x20, 			/* 8--0B00100000	  */
										0x21, 			/* 9--0B00100001	  */
										0x22, 			/* A--0B00100010	  */
										0x38, 			/* b--0B00111000	  */
										0xB4, 			/* C--0B10110100	  */
										0x68, 			/* d--0B01101000	  */
										0x34, 			/* E--0b00110100	  */
										0x36, 			/* F--0b00110110	  */
										0x80, 			/* 0.--0b01000000	  */		
										0xCB, 			/* 1.--0b01111001	  */
										0x44, 			/* 2.--0b00100100	  */
										0x41, 			/* 3.--0b00110000	  */
										0x0B, 			/* 4.--0b00011001  	  */
										0x11, 			/* 5.--0b00100010	  */
										0x10, 			/* 6.--0b00000010	  */
										0xC3, 			/* 7.--0b01111000	  */
										0x00, 			/* 8.--0b00000000	  */
										0x01, 			/* 9.--0b00010000	  */
										0xA2, 			/* ^ --0b10100010	  */
										0x7F, 			/* - --0b01111111	  */
										0xFD, 			/* _ -- 0b11111101	  */
										0xDF, 			/* . -- 0b11011111	  */
										0xF5, 			/* = -- 0b11110101	  */
										0xFF  			/*   -- 0b11111111	  */
									} ;
#endif																		
	LED_SEG = data[encode];
	asm("\tRPT #16");
	asm("\tNOP");
	LED_BIT = shift_data(bit);
	asm("\tRPT #16");
	asm("\tNOP");
	return;	
}          
void Disp_LED_Traf(unsigned int state,unsigned int bit)
{
	static unsigned int  LED_traf_state = INIT_LED_TRAF_STATE;
	shift_traf(LED_traf_state,state,bit);       	
	LED_TRAF  =  LED_traf_state;                
	asm("\tRPT #16");
	asm("\tNOP");
	return;
}
void Disp_LED_sign(unsigned int state,unsigned int bit)
{
	static unsigned int  LED_sign_state = INIT_LED_SIGN_STATE;
	shift_sign(LED_sign_state,state,bit);    
	LED_SIGN  =  LED_sign_state; 
	asm("\tRPT #16");
	asm("\tNOP");
	return;
}
void Close_LED_Data(void)
{
	LED_SEG = INIT_LED_DATA_SEG;    
	asm("\tRPT #16");
	asm("\tNOP");
	LED_BIT = INIT_LED_DATA_BIT;
	asm("\tRPT #16");
	asm("\tNOP");
	return;
}
void Close_LED_Traf(void)
{                          
	int	i;
	for(i=0;i<4;i++)       	
	{             
		Disp_LED_Traf(0,i);
	}
	return;
}
void Close_LED_sign(void)
{
	int	i;
	for(i=0;i<8;i++)       	
	{             
		Disp_LED_sign(0,i);
	}
	return;
}
