/******************************************************************************/
/* lcd_graphic_drv.c                                                            */
/*                                                                            */
/* This is proprietary information, not to be published -- TI INTERNAL DATA   */
/* Copyright (C) 1999, Texas Instruments, Inc.  All Rights Reserved.          */
/*                                                                            */
/* Author: Stephen Handley                                                    */
/* Date: February 16, 2000                                                    */
/******************************************************************************/
#include "lcd.h"
#include "lcd_86.h"
#include "mmdrv.h"
unsigned int cur_col,cur_row;

void Unlong_to_String(unsigned long data,unsigned int count,char *chars)
{
	static unsigned int hexdata[16]={0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,
									 0x38,0x39,0x41,0x42,0x43,0x44,0x45,0x46};
    int i,number = 0; 
	chars[number++] = 0;
	do 
	{
	
		for(i = number-1;i >=0 ;i--)
		{
		    chars[i+1] = chars[i];
		}  
		number++;  
		chars[0]= hexdata[(unsigned int)(data%((unsigned long)count))];
		data = data/((unsigned long)count);
	}while(data);
	return;								 
}
void Long_to_String(long data,char *chars)
{
    unsigned long undata;
    int i,start=0,number = 0; 
	if(data <0)
	{
		chars[number++] = '-';
		undata = ~data + 1;	
		start = 1;
	}   
	else
	{
		undata =data;
	}
	chars[number++] = 0;        
	do 
	{
	
		for(i = number-1;i >=start ;i--)
		{
		    chars[i+1] = chars[i];
		}  
		number++;  
		chars[start]= 0x30 + (unsigned int)(undata%10L);
		undata = undata/10L;
	}while(undata);
	return;								 
}
void Unint_to_String(unsigned int data,unsigned int count,char *chars)
{
	static unsigned int hexdata[16]={0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,
									 0x38,0x39,0x41,0x42,0x43,0x44,0x45,0x46};
    int i,number = 0; 
	chars[number++] = 0;
	do 
	{
	
		for(i = number-1;i >=0 ;i--)
		{
		    chars[i+1] = chars[i];
		}  
		number++;  
		chars[0]= hexdata[data%count];
		data = data/count;
	}while(data);
	return;								 
}
void Int_to_String(int data,char *chars)
{
    unsigned int undata;
    int i,start=0,number = 0; 
	if(data <0)
	{
		chars[number++] = '-';
		undata = ~data + 1;	
		start = 1;
	}     
	else
	{
		undata = data;
	}
	chars[number++] = 0;        
	do 
	{
	
		for(i = number-1;i >=start ;i--)
		{
		    chars[i+1] = chars[i];
		}  
		number++;  
		chars[start]= 0x30 + undata%10;
		undata = undata/10;
	}while(undata);
	return;								 
}
void Float16_to_String(int data,unsigned int qbit,unsigned int disnum,char *chars)
{   
    unsigned long diasdata =5L;
	unsigned int undata;
	unsigned int undata1;
	unsigned long undata2;
	int i,start=0,number = 0; 
	for(i =1;i<disnum;i++)
	{       
		diasdata *= 10L;	
	}
	if(data <0)
	{
		chars[number++] = '-';
		undata = ~data + 1;	
		start = 1;
	}     
	else
	{
		undata = data;
	}                   
	undata1 = undata >> qbit;            
	chars[number++] = '.';
	undata2 = 0 ;
	for(i =(1<<(qbit-1)) ;i >0; i= i>>1)
	{ 
		if(undata&i) undata2 +=  diasdata;
		diasdata = diasdata>>1;
	}
	 
	for(i = 0 ; i<disnum;i++)     
	{
		chars[number+disnum-1-i] = 0x30 + (unsigned int)(undata2%10L);
		undata2 = undata2/10L;
	}
	number +=disnum;	
	chars[number++] = 0;
	do 
	{
		for(i = number-1;i >=start ;i--)
		{
		    chars[i+1] = chars[i];
		}  
		number++;  
		chars[start]= 0x30 + undata1%10;
		undata1 = undata1/10;
	}while(undata1);  
	return;								 
}
void LCD_pr_chars(char string[],int len)
{
    int found_null = 0;
    int i;

    for (i=0;i<len;i++)
    {
        if(string[i] == '\0')
        {
            found_null = 1;
        }
        if(found_null)
        {
            LCD_nextchar(' ');
        }
        else
        {
            LCD_nextchar(string[i]);
        }

    }
}

char LCD_putchar(char data)
{
  int i,CG_data;
  unsigned address;
  if (( data >= START_CHAR ) && (data <= END_CHAR ))
  {
    address = (data - START_CHAR) * WORDS_PER_CHAR;
    for ( i=0;i<WORDS_PER_CHAR;i++)
    {
            CG_data = CharGen_6x8[address+2-i];
            Lcd_writedata(cur_row, cur_col++,CG_data & 0x00FF);
			Lcd_writedata(cur_row, cur_col++,CG_data >> 8);
    }
  }
  return(data);
}
#if 0
const unsigned CharGen_6x8[]  =
{
/*           Data                             ASCII    HEX   Decimal                */
             0x0202, 0x0202, 0x0200,       /* (EQ 1)   0x00     0                   */
             0x0606, 0x0606, 0x0600,       /* (EQ 2)   0x01     1                   */
             0x0E0E, 0x0E0E, 0x0E00,       /* (EQ 3)   0x02     2                   */
             0x1E1E, 0x1E1E, 0x1E00,       /* (EQ 4)   0x03     3                   */
             0x3E3E, 0x3E3E, 0x3E00,       /* (EQ 5)   0x04     4                   */
             0x7E7E, 0x7E7E, 0x7E00,       /* (EQ 6)   0x05     5                   */
             0xFEFE, 0xFEFE, 0xFE00,       /* (EQ 7)   0x06     6                   */
             0x2040, 0xFE40, 0x2000,       /* (Up Arrow) 0x07   7                   */
             0x0804, 0xFE04, 0x0800,       /* (Down)   0x08     8                   */
             0x1038, 0x5410, 0x1000,       /* (Left)   0x09     9                   */
             0x1010, 0x5438, 0x1000,       /* (Right)  0x0A    10                   */
             0x1028, 0x5428, 0x4400,       /* <<       0x0B    11  "Rewind"         */
             0x4428, 0x5428, 0x1000,       /* >>       0x0C    12  "Forward"        */
             0x041C, 0x7C1C, 0x0400,       /* (solid ^) 0x0D   13                   */
             0x4070, 0x7C70, 0x4000,       /* (solid v) 0x0E   14                   */
             0x7C7C, 0x7C7C, 0x7C00,       /* (box)     0x0F   15  "STOP"           */
             0x7C38, 0x3810, 0x1000,       /* (solid >) 0x10   16  "Play"           */
             0x1010, 0x3838, 0x7C00,       /* (solid <) 0x11   17  "Play Rev"       */
             0x7C38, 0x3810, 0x7C00,       /* (solid >|)0x12   18  "Skip Fwd"       */
             0x7C10, 0x3838, 0x7C00,       /* (solid |<)0x13   19  "Skip Back"      */
             0x7C00, 0x007C, 0x0000,       /* (||)      0x14   20  "Pause"          */
             0x4040, 0x7F40, 0x4000,       /* (EQ T)    0x15   21  Top EQ           */
             0x0202, 0xFE02, 0x0200,       /* (EQ  )    0x16   22  Bottom EQ        */
             0x1010, 0xFF10, 0x1000,       /* (EQ t)    0x17   23  Mid EQ           */
             0x0000, 0xFF00, 0x0000,       /* (EQ |)    0x18   24  Mid EQ |         */
             0x4040, 0x7F7F, 0x4000,       /* (EQ T)    0x19   25  Top EQ  Bold     */
             0x0202, 0xFEFE, 0x0200,       /* (EQ  )    0x1A   26  Bottom EQ Bold   */
             0x1010, 0xFFFF, 0x1000,       /* (EQ t)    0x1B   27  Mid EQ   Bold    */
             0x0000, 0xFFFF, 0x0000,       /* (EQ |)    0x1C   28  Mid EQ | Bold    */
             0x0E0E, 0xFE00, 0x0000,       /* ()        0x1D   29  Note             */
             0x0E0E, 0xFE80, 0x0000,       /* ()        0x1E   30  Note             */
             0x0E0E, 0xFEA0, 0x0000,       /* ()        0x1F   31  Note             */

             0x0000, 0x0000, 0x0000,       /* (space)  0x20    32                   */
             0x0000, 0xF200, 0x0000,       /* !        0x21    33                   */
             0x00E0, 0x00E0, 0x0000,       /* "        0x22    34                   */
             0x28FE, 0x28FE, 0x2800,       /* #        0x23    35                   */
             0x2454, 0xFE54, 0x4800,       /* $        0x24    36                   */
             0xC4C8, 0x1026, 0x4600,       /* %        0x25    37                   */
             0x6C92, 0xAA44, 0x0A00,       /* &        0x26    38                   */
             0x00A0, 0xC000, 0x0000,       /* '        0x27    39                   */
             0x0038, 0x4482, 0x0000,       /* (        0x28    40                   */
             0x0082, 0x4438, 0x0000,       /* )        0x29    41                   */
             0x2810, 0x7C10, 0x2800,       /* *        0x2A    42                   */
             0x1010, 0x7C10, 0x1000,       /* +        0x2B    43                   */
             0x000A, 0x0C00, 0x0000,       /* ,        0x2C    44                   */
             0x1010, 0x1010, 0x1000,       /* -        0x2D    45                   */
             0x0006, 0x0600, 0x0000,       /* .        0x2E    46                   */
             0x0408, 0x1020, 0x4000,       /* /        0x2F    47                   */
             0x7C8A, 0x92A2, 0x7C00,       /* 0        0x30    48                   */
             0x0042, 0xFE02, 0x0000,       /* 1        0x31    49                   */
             0x4286, 0x8A92, 0x6200,       /* 2        0x32    50                   */
             0x4482, 0xA2D2, 0x8C00,       /* 3        0x33    51                   */
             0x1828, 0x48FE, 0x0800,       /* 4        0x34    52                   */
             0xE4A2, 0xA2A2, 0x9C00,       /* 5        0x35    53                   */
             0x3C52, 0x9292, 0x0C00,       /* 6        0x36    54                   */
             0x808E, 0x90A0, 0xC000,       /* 7        0x37    55                   */
             0x6C92, 0x9292, 0x6C00,       /* 8        0x38    56                   */
             0x6092, 0x9294, 0x7800,       /* 9        0x39    57                   */
             0x006C, 0x6C00, 0x0000,       /* :        0x3A    58                   */
             0x00DA, 0xDC00, 0x0000,       /* ;        0x3B    59                   */
             0x1028, 0x4482, 0x0000,       /* <        0x3C    60                   */
             0x2828, 0x2828, 0x2800,       /* =        0x3D    61                   */
             0x0082, 0x4428, 0x1000,       /* >        0x3E    62                   */
             0X4080, 0x8A90, 0x6000,       /* ?        0x3F    63                   */
             0x4C92, 0x9E82, 0x7C00,       /* @        0x40    64                   */
             0x7E88, 0x8888, 0x7E00,       /* A        0x41    65                   */
             0xFE92, 0x9292, 0x6C00,       /* B        0x42    66                   */
             0x7C82, 0x8282, 0x4400,       /* C        0x43    67                   */
             0xFE82, 0x8244, 0x3800,       /* D        0x44    68                   */
             0xFE92, 0x9292, 0x8200,       /* E        0x45    69                   */
             0xFE90, 0x9090, 0x8000,       /* F        0x46    70                   */
             0x7C82, 0X9292, 0x5E00,       /* G        0x47    71                   */
             0xFE10, 0x1010, 0xFE00,       /* H        0x48    72                   */
             0x0082, 0xFE82, 0x0000,       /* I        0x49    73                   */
             0x0402, 0x82FC, 0x8000,       /* J        0x4A    74                   */
             0xFE10, 0x2844, 0x8200,       /* K        0x4B    75                   */
             0xFE02, 0x0202, 0x0200,       /* L        0x4C    76                   */
             0xFE40, 0x3040, 0xFE00,       /* M        0x4D    77                   */
             0xFE20, 0x1008, 0xFE00,       /* N        0x4E    78                   */
             0x7C82, 0x8282, 0x7C00,       /* O        0x5F    79                   */
             0xFE90, 0x9090, 0x6000,       /* P        0x50    80                   */
             0x7C82, 0x8A84, 0x7A00,       /* Q        0x51    81                   */
             0XFE90, 0x9894, 0x6200,       /* R        0x52    82                   */
             0x6492, 0x9292, 0x4C00,       /* S        0x53    83                   */
             0x8080, 0xFE80, 0x8000,       /* T        0x54    84                   */
             0xFC02, 0x0202, 0xFC00,       /* U        0x55    85                   */
             0xF804, 0x0204, 0xF800,       /* V        0x56    86                   */
             0xFC02, 0x1C02, 0xFC00,       /* W        0x57    87                   */
             0xC628, 0x1028, 0xC600,       /* X        0x58    88                   */
             0xE010, 0x0E10, 0xE000,       /* Y        0x59    89                   */
             0x868A, 0x92A2, 0xC200,       /* Z        0x5A    90                   */
             0x00FE, 0x8282, 0x0000,       /* [        0x5B    91                   */
             0x4020, 0x1008, 0x0400,       /* \        0x5C    92                   */
             0x0082, 0x82fe, 0x0000,       /* ]        0x5D    93                   */
             0x3040, 0x8040, 0x3000,       /* ^        0x5E    94                   */
             0x0202, 0x0202, 0x0200,       /* _        0x5F    95                   */
             0x0080, 0x4020, 0x0000,       /* `        0x60    96                   */
             0x042A, 0x2A2A, 0x3C00,       /* a        0x61    97                   */
             0xFE12, 0x2222, 0x1C00,       /* b        0x62    98                   */
             0x1C22, 0x2222, 0x0400,       /* c        0x63    99                   */
             0x1C22, 0x2212, 0xFE00,       /* d        0x64   100                   */
             0x1C2A, 0x2A2A, 0x1800,       /* e        0x65   101                   */
             0x107E, 0x9080, 0x4000,       /* f        0x66   102                   */
             0x304A, 0x4A4A, 0x7C00,       /* g        0x67   103                   */
             0xFE10, 0x2020, 0x1E00,       /* h        0x68   104                   */
             0x0022, 0xBE02, 0x0000,       /* i        0x69   105                   */
             0x0024, 0x22BC, 0x0000,       /* j        0x6A   106                   */
             0xFE08, 0x1422, 0x0000,       /* k        0x6B   107                   */
             0x0082, 0xFE02, 0x0000,       /* l        0x6C   108                   */
             0x3E20, 0x1820, 0x1E00,       /* m        0x6D   109                   */
             0x3E10, 0x2020, 0x1E00,       /* n        0x6E   110                   */
             0x1C22, 0x2222, 0x1C00,       /* o        0x6F   111                   */
             0x3E28, 0x2828, 0x1000,       /* p        0x70   112                   */
             0x1028, 0x2818, 0x3E00,       /* q        0x71   113                   */
             0x3E10, 0x2020, 0x1000,       /* r        0x72   114                   */
             0x122A, 0x2A2A, 0x0400,       /* s        0x73   115                   */
             0x20FC, 0x2202, 0x0400,       /* t        0x74   116                   */
             0x3C02, 0x0204, 0x3E00,       /* u        0x75   117                   */
             0x3804, 0x0204, 0x3800,       /* v        0x76   118                   */
             0x3C02, 0x0C02, 0x3C00,       /* w        0x77   119                   */
             0x2214, 0x0814, 0x2200,       /* x        0x78   120                   */
             0x300A, 0x0A0A, 0x3C00,       /* y        0x79   121                   */
             0x2226, 0x2A32, 0x2200,       /* z        0x7A   122                   */
             0x0010, 0x6C82, 0x0000,       /* {        0x7B   123                   */
             0x0000, 0xFE00, 0x0000,       /* |        0x7C   124                   */
             0x0082, 0x6C10, 0x0000,       /* }        0x7D   125                   */
             0x1020, 0x1804, 0x0800,       /* ~        0x7E   126                   */
             0xFEFE, 0xFEFE, 0xFE00,       /* (black)  0x7F   127                   */
             0x004A, 0x0044, 0x004B,
             0x0050, 0x0052, 0x0047,
             0x004D, 0x0054, 0x004E,
             0x004A, 0x0020, 0x0048,
             0x0053, 0x0020, 0x0048,
             0x0048, 0x0047, 0x0047,
             0x004B, 0x0020, 0x0043,
             0x0047, 0x0052, 0x0043,
             0x0054, 0x0020, 0x004D,
             0x0043, 0x0020, 0x004C,
             0x0041, 0x0020, 0x0052,
             0x004A, 0x0020, 0x0052,
             0x0044, 0x0057, 0x0047,
             0x0052, 0x0020, 0x0043,
             0x0057, 0x0020, 0x0043,
             0x0041, 0x0020, 0x0041,
             0x004d, 0x0020, 0x0050,
             0x0042, 0x004D, 0x004B
};
#else	/*asc2 Rotate 180*/
const unsigned CharGen_6x8[]  =
{
//           Data                             ASCII    HEX   Decimal
             0x0040, 0x4040, 0x4000,       // (EQ 1)   0x00     0   0x0202, 0x0202, 0x0200,
             
             0x0060, 0x6060, 0x6060,       // (EQ 2)   0x01     1   0x0606, 0x0606, 0x0600,
             
             0x0060, 0x6060, 0x6060,       // (EQ 3)   0x02     2   0x0606, 0x0606, 0x0600,
             
             0x0078, 0x7878, 0x7878,       // (EQ 4)   0x03     3   0x1E1E, 0x1E1E, 0x1E00,
             
             0x007C, 0x7C7C, 0x7C7C,       // (EQ 5)   0x04     4   0x3E3E, 0x3E3E, 0x3E00,
             
             0x00E7, 0xE7E7, 0xE7E7,       // (EQ 6)   0x05     5   0x7E7E, 0x7E7E, 0x7E00,
             
             0x007F, 0x7F7F, 0x7F7F,       // (EQ 7)   0x06     6   0xFEFE, 0xFEFE, 0xFE00
             
             0x0004, 0x027F, 0x0204,       // (Up Arrow) 0x07   7   0x2040, 0xFE40, 0x2000,
             
             0x0010, 0x207F, 0x2010,       // (Down)   0x08     8   0x0804, 0xFE04, 0x0800,
             
             0x0008, 0x082A, 0x1C08,       // (Left)   0x09     9   0x1038, 0x5410, 0x1000,
             
             0x0008, 0x1C2A, 0x0808,       // (Right)  0x0A    10   0x1010, 0x5438, 0x1000,
             
             0x0022, 0x142A, 0x1408,       // <<       0x0B    11   0x1028, 0x5428, 0x4400,"Rewind"
             
             0x0008, 0x142A, 0x1422,       // >>       0x0C    12   0x4428, 0x5428, 0x1000,"Forward"
             
             0x0020, 0x383E, 0x3820,       // (solid ^) 0x0D   13   0x041C, 0x7C1C, 0x0400,
             
             0x0002, 0x0E3E, 0x0E02,       // (solid v) 0x0E   14   0x4070, 0x7C70, 0x4000,
             
             //0x003E, 0x3E3E, 0x3E3E,       // (box)     0x0F   15   0x7C7C, 0x7C7C, 0x7C00,"STOP"
             0x3E3E, 0x3E3E, 0x3E00,  
             
             //0x0008, 0x081C, 0x1C3E,       // (solid >) 0x10   16   0x7C38, 0x3810, 0x1000,"Play"
             0x0808, 0x1C1C, 0x3E00,
             
             //0x003E, 0x1C1C, 0x0808,       // (solid <) 0x11   17   0x1010, 0x3838, 0x7C00,"Play Rev"
             0x3E1C, 0x1C08, 0x0800,
             
             //0x003E, 0x081C, 0x1C3E,       // (solid >|)0x12   18   0x7C38, 0x3810, 0x7C00,"Skip Fwd"
             0x3E08, 0x1C1C, 0x3E00,
             
             //0x003E, 0x1C1C, 0x083E,       // (solid |<)0x13   19   0x7C10, 0x3838, 0x7C00,"Skip Back"
             0x3E1C, 0x1C08, 0x3E00,
             
             //0x0000, 0x3E00, 0x003E,       // (||)      0x14   20   0x7C00, 0x007C, 0x0000,"Pause"
             0x003E, 0x0000, 0x3E00,
             
             0x0002, 0x02FE, 0x0202,       // (EQ T)    0x15   21   0x4040, 0x7F40, 0x4000,Top EQ
             
             0x0040, 0x407F, 0x4040,       // (EQ  )    0x16   22   0x0202, 0xFE02, 0x0200,Bottom EQ
             
             0x0008, 0x08FF, 0x0808,       // (EQ t)    0x17   23   0x1010, 0xFF10, 0x1000,Mid EQ
             
             0x0000, 0x00FF, 0x0000,       // (EQ |)    0x18   24   0x0000, 0xFF00, 0x0000,Mid EQ |
             
             0x0002, 0xFEFE, 0x0202,       // (EQ T)    0x19   25   0x4040, 0x7F7F, 0x4000,Top EQ  Bold
             
             0x0040, 0x7F7F, 0x4040,       // (EQ  )    0x1A   26   0x0202, 0xFEFE, 0x0200,Bottom EQ Bold
             
             0x0008, 0xFFFF, 0x0808,       // (EQ t)    0x1B   27   0x1010, 0xFFFF, 0x1000,Mid EQ   Bold
             
             0x0000, 0xFFFF, 0x0000,       // (EQ |)    0x1C   28   0x0000, 0xFFFF, 0x0000,Mid EQ | Bold
             
             0x0000, 0x007F, 0x7070,       // ()        0x1D   29   0x0E0E, 0xFE00, 0x0000,Note
             
             0x0000, 0x017F, 0x7070,       // ()        0x1E   30   0x0E0E, 0xFE80, 0x0000,Note
             
             0x0000, 0x057F, 0x7070,       // ()        0x1F   31   0x0E0E, 0xFEA0, 0x0000,Note

             
             
             0x0000, 0x0000, 0x0000,       // (space)  0x20    32   0x0000, 0x0000, 0x0000,
             
             0x0000, 0x004F, 0x0000,       // !        0x21    33   0x0000, 0xF200, 0x0000,
             
             0x0000, 0x0700, 0x0700,       // "        0x22    34   0x00E0, 0x00E0, 0x0000,
             
             0x0014, 0x7F14, 0x7F14,       // #        0x23    35   0x28FE, 0x28FE, 0x2800,
             
             0x0012, 0x2A7F, 0x2A24,       // $        0x24    36   0x2454, 0xFE54, 0x4800,
             
             0x0062, 0x6408, 0x1323,       // %        0x25    37   0xC4C8, 0x1026, 0x4600,
             
             0x0050, 0x2255, 0x4936,       // &        0x26    38   0x6C92, 0xAA44, 0x0A00,
             
             0x0000, 0x0003, 0x0500,       // '        0x27    39   0x00A0, 0xC000, 0x0000,
             
             0x0000, 0x4122, 0x1C00,       // (        0x28    40   0x0038, 0x4482, 0x0000,
             
             0x0000, 0x1C22, 0x4100,       // )        0x29    41   0x0082, 0x4438, 0x0000,
             
             0x0014, 0x083E, 0x0814,       // *        0x2A    42   0x2810, 0x7C10, 0x2800,
             
             0x0008, 0x083E, 0x0808,       // +        0x2B    43   0x1010, 0x7C10, 0x1000,
             
             0x0000, 0x0030, 0x5000,       // ,        0x2C    44   0x000A, 0x0C00, 0x0000,
             
             0x0008, 0x0808, 0x0808,       // -        0x2D    45   0x1010, 0x1010, 0x1000,
             
             0x0000, 0x0060, 0x6000,       // .        0x2E    46   0x0006, 0x0600, 0x0000,
             
             0x0002, 0x0408, 0x1020,       // /        0x2F    47   0x0408, 0x1020, 0x4000,
             
             0x003E, 0x4549, 0x513E,       // 0        0x30    48   0x7C8A, 0x92A2, 0x7C00,
             
             0x0000, 0x407F, 0x4200,       // 1        0x31    49   0x0042, 0xFE02, 0x0000,
             
             0x0046, 0x4951, 0x6142,       // 2        0x32    50   0x4286, 0x8A92, 0x6200,
             
             0x0031, 0x4B45, 0x4122,       // 3        0x33    51   0x4482, 0xA2D2, 0x8C00,
             
             0x0010, 0x7F12, 0x1418,       // 4        0x34    52   0x1828, 0x48FE, 0x0800,
             
             0x0039, 0x4545, 0x4527,       // 5        0x35    53   0xE4A2, 0xA2A2, 0x9C00,
             
             0x0030, 0x4949, 0x4A3C,       // 6        0x36    54   0x3C52, 0x9292, 0x0C00,
             
             0x0003, 0x0509, 0x7101,       // 7        0x37    55   0x808E, 0x90A0, 0xC000,
             
             0x0036, 0x4949, 0x4936,       // 8        0x38    56   0x6C92, 0x9292, 0x6C00,
             
             0x001E, 0x2949, 0x4906,       // 9        0x39    57   0x6092, 0x9294, 0x7800,
             
             0x0000, 0x0036, 0x3600,       // :        0x3A    58   0x006C, 0x6C00, 0x0000,
             
             0x0000, 0x003B, 0x5B00,       // ;        0x3B    59   0x00DA, 0xDC00, 0x0000,
             
             0x0000, 0x4122, 0x1408,       // <        0x3C    60   0x1028, 0x4482, 0x0000,
             
             0x0014, 0x1414, 0x1414,       // =        0x3D    61   0x2828, 0x2828, 0x2800,
             
             0x0008, 0x1422, 0x4100,       // >        0x3E    62   0x0082, 0x4428, 0x1000,
             
             0X0006, 0x0951, 0x0102,       // ?        0x3F    63   0X4080, 0x8A90, 0x6000,
             
             0x003E, 0x4179, 0x4932,       // @        0x40    64   0x4C92, 0x9E82, 0x7C00,
             
             0x007E, 0x1111, 0x117E,       // A        0x41    65   0x7E88, 0x8888, 0x7E00,
             
             0x0036, 0x4949, 0x497F,       // B        0x42    66   0xFE92, 0x9292, 0x6C00,
             
             0x0022, 0x4141, 0x413E,       // C        0x43    67   0x7C82, 0x8282, 0x4400,
             
             0x001C, 0x2241, 0x417F,       // D        0x44    68   0xFE82, 0x8244, 0x3800,
             
             0x0041, 0x4949, 0x497F,       // E        0x45    69   0xFE92, 0x9292, 0x8200,
             
             0x0001, 0x0909, 0x097F,       // F        0x46    70   0xFE90, 0x9090, 0x8000,
             
             0x007A, 0X4949, 0x413E,       // G        0x47    71   0x7C82, 0X9292, 0x5E00,
             
             0x007F, 0x0808, 0x087F,       // H        0x48    72   0xFE10, 0x1010, 0xFE00,
             
             0x0000, 0x417F, 0x4100,       // I        0x49    73   0x0082, 0xFE82, 0x0000,
             
             0x0001, 0x3F41, 0x4020,       // J        0x4A    74   0x0402, 0x82FC, 0x8000,
             
             0x0041, 0x2214, 0x087F,       // K        0x4B    75   0xFE10, 0x2844, 0x8200,
             
             0x0040, 0x4040, 0x407F,       // L        0x4C    76   0xFE02, 0x0202, 0x0200,
             
             0x007F, 0x020C, 0x027F,       // M        0x4D    77   0xFE40, 0x3040, 0xFE00,
             
             0x007F, 0x1008, 0x047F,       // N        0x4E    78   0xFE20, 0x1008, 0xFE00,
             
             0x003E, 0x4141, 0x413E,       // O        0x5F    79   0x7C82, 0x8282, 0x7C00,
             
             0x0006, 0x0909, 0x097F,       // P        0x50    80   0xFE90, 0x9090, 0x6000,
             
             0x005E, 0x2151, 0x413E,       // Q        0x51    81   0x7C82, 0x8A84, 0x7A00,
             
             0X0046, 0x2919, 0x097F,       // R        0x52    82   0XFE90, 0x9894, 0x6200,
             
             0x0032, 0x4949, 0x4926,       // S        0x53    83   0x6492, 0x9292, 0x4C00,
             
             0x0001, 0x017F, 0x0101,       // T        0x54    84   0x8080, 0xFE80, 0x8000,
             
             0x003F, 0x4040, 0x403F,       // U        0x55    85   0xFC02, 0x0202, 0xFC00,
             
             0x001F, 0x2040, 0x201F,       // V        0x56    86   0xF804, 0x0204, 0xF800,
             
             0x003F, 0x4038, 0x403F,       // W        0x57    87   0xFC02, 0x1C02, 0xFC00,
             
             0x0063, 0x1408, 0x1463,       // X        0x58    88   0xC628, 0x1028, 0xC600,
             
             0x0007, 0x0870, 0x0807,       // Y        0x59    89   0xE010, 0x0E10, 0xE000,
             
             0x0043, 0x4549, 0x5161,       // Z        0x5A    90   0x868A, 0x92A2, 0xC200,
             
             0x0000, 0x4141, 0x7F00,       // [        0x5B    91   0x00FE, 0x8282, 0x0000,
             
             0x0020, 0x1008, 0x0402,       // \        0x5C    92   0x4020, 0x1008, 0x0400,
             
             0x0000, 0x7F41, 0x4100,       // ]        0x5D    93   0x0082, 0x82fe, 0x0000,
             
             0x000C, 0x0201, 0x020C,       // ^        0x5E    94   0x3040, 0x8040, 0x3000,
             
             0x0040, 0x4040, 0x4040,       // _        0x5F    95   0x0202, 0x0202, 0x0200,
             
             0x0000, 0x0402, 0x0100,       // `        0x60    96   0x0080, 0x4020, 0x0000,
             
             0x003C, 0x5454, 0x5420,       // a        0x61    97   0x042A, 0x2A2A, 0x3C00,
             
             0x0038, 0x4444, 0x487F,       // b        0x62    98   0xFE12, 0x2222, 0x1C00,
             
             0x0020, 0x4444, 0x4438,       // c        0x63    99   0x1C22, 0x2222, 0x0400,
             
             0x007F, 0x4844, 0x4438,       // d        0x64   100   0x1C22, 0x2212, 0xFE00,
             
             0x0018, 0x5454, 0x5438,       // e        0x65   101   0x1C2A, 0x2A2A, 0x1800,
             
             0x0002, 0x0109, 0x7E08,       // f        0x66   102   0x107E, 0x9080, 0x4000,
             
             0x003E, 0x5252, 0x520C,       // g        0x67   103   0x304A, 0x4A4A, 0x7C00,
             
             0x0078, 0x0404, 0x087F,       // h        0x68   104   0xFE10, 0x2020, 0x1E00,
             
             0x0000, 0x407D, 0x4400,       // i        0x69   105   0x0022, 0xBE02, 0x0000,
             
             0x0000, 0x3D44, 0x2400,       // j        0x6A   106   0x0024, 0x22BC, 0x0000,
             
             0x0000, 0x4428, 0x107F,       // k        0x6B   107   0xFE08, 0x1422, 0x0000,
             
             0x0000, 0x407F, 0x4100,       // l        0x6C   108   0x0082, 0xFE02, 0x0000,
             
             0x0078, 0x0418, 0x047C,       // m        0x6D   109   0x3E20, 0x1820, 0x1E00,
             
             0x0078, 0x0404, 0x087C,       // n        0x6E   110   0x3E10, 0x2020, 0x1E00,
             
             0x0038, 0x4444, 0x4438,       // o        0x6F   111   0x1C22, 0x2222, 0x1C00,
             
             0x0008, 0x1414, 0x147C,       // p        0x70   112   0x3E28, 0x2828, 0x1000,
             
             0x007C, 0x1814, 0x1408,       // q        0x71   113   0x1028, 0x2818, 0x3E00,
             
             0x0008, 0x0404, 0x087C,       // r        0x72   114   0x3E10, 0x2020, 0x1000,
             
             0x0020, 0x5454, 0x5448,       // s        0x73   115   0x122A, 0x2A2A, 0x0400,
             
             0x0020, 0x4044, 0x3F04,       // t        0x74   116   0x20FC, 0x2202, 0x0400,
             
             0x007C, 0x2040, 0x403C,       // u        0x75   117   0x3C02, 0x0204, 0x3E00,
             
             0x001C, 0x2040, 0x201C,       // v        0x76   118   0x3804, 0x0204, 0x3800,
             
             0x003C, 0x4030, 0x403C,       // w        0x77   119   0x3C02, 0x0C02, 0x3C00,
             
             0x0044, 0x2810, 0x2844,       // x        0x78   120   0x2214, 0x0814, 0x2200,
             
             0x003C, 0x5050, 0x500C,       // y        0x79   121   0x300A, 0x0A0A, 0x3C00,
             
             0x0044, 0x4C54, 0x6444,       // z        0x7A   122   0x2226, 0x2A32, 0x2200,
             
             0x0000, 0x4136, 0x0800,       // {        0x7B   123   0x0010, 0x6C82, 0x0000,
             
             0x0000, 0x007F, 0x0000,       // |        0x7C   124   0x0000, 0xFE00, 0x0000,
             
             0x0000, 0x0836, 0x4100,       // }        0x7D   125   0x0082, 0x6C10, 0x0000,
             
             0x0010, 0x2018, 0x0408,       // ~        0x7E   126   0x1020, 0x1804, 0x0800,
             
             0x007F, 0x7F7F, 0x7F7F,       // (black)  0x7F   127   0xFEFE, 0xFEFE, 0xFE00,
             
             0xD200, 0x2200, 0x5200,       //                       0x004A, 0x0044, 0x004B,
             
             0xE200, 0x4A00, 0x0A00,       //                       0x0050, 0x0052, 0x0047,
             
             0x7200, 0x2A00, 0xB200,       //                       0x004D, 0x0054, 0x004E,
             
             0x1200, 0x0400, 0x5200,       //                       0x004A, 0x0020, 0x0048,
             
             0x1200, 0x0400, 0xCA00,       //                       0x0053, 0x0020, 0x0048,
             
             0xE200, 0xE200, 0x1200,       //                       0x0048, 0x0047, 0x0047,
             
             0xC200, 0x0400, 0xD200,       //                       0x004B, 0x0020, 0x0043,
             
             0xC200, 0x4A00, 0xE200,       //                       0x0047, 0x0052, 0x0043,
             
             0xB200, 0x0400, 0x2A00,       //                       0x0054, 0x0020, 0x004D,
             
             0x3200, 0x0400, 0xC200,       //                       0x0043, 0x0020, 0x004C,
             
             0x4A00, 0x0400, 0x4A00,       //                       0x0041, 0x0020, 0x0052,
             
             0x4A00, 0x0400, 0x5200,       //                       0x004A, 0x0020, 0x0052,
             
             0xE200, 0xEA00, 0x2200,       //                       0x0044, 0x0057, 0x0047,
             
             0xC200, 0x0400, 0x4A00,       //                       0x0052, 0x0020, 0x0043,
             
             0xC200, 0x0400, 0xEA00,       //                       0x0057, 0x0020, 0x0043,
             
             0x8200, 0x0400, 0x8200,       //                       0x0041, 0x0020, 0x0041,
             
             0x0A00, 0x0400, 0xB200,       //                       0x004d, 0x0020, 0x0050,
             
             0xD200, 0xB200, 0xD200,       //                       0x0042, 0x004D, 0x004B
             
             0x7F49, 0x4949, 0x4100,       // 0x92
             
             0x7F02, 0x0C02, 0x7F00,       // 0x93 M 
             
             0x0101, 0x7F01, 0x0100,       // 0x94 T        0x54    84   0x8080, 0xFE80, 0x8000,
             
             0x3F40, 0x4040, 0x3F00        // 0x95 U        0x55    85
             
};
#endif    


