/******************************************************************************/
/* uart.h                                                                    */
/*                                                                            */
/* This is proprietary information, not to be published -- DIGIPRO DATA   	  */
/* Copyright (C) 2002, DigiPro Information Co.,Ltd.  All Rights Reserved.     */
/*                                                                            */
/* Author: Wu DingMing                                                        */
/* Date: August 12, 2002                                                      */
/******************************************************************************/
/******************************************************************************/
/*	+----+--+--+--+--------------------------------------------------------+  */
/*  |DLAB|A2|A1|A0| 				REGISTER							   |  */
/*	+----+--+--+--+--------------------------------------------------------+  */
/*  |  0 | L| L| L|	Receiver buffer (R), transmitter holding register (W)  |  */
/*	+----+--+--+--+--------------------------------------------------------+  */
/*  |  0 | L| L| H|	Interrupt enable register							   |  */
/*	+----+--+--+--+--------------------------------------------------------+  */
/*  |  1 | L| L| L|	Divisor latch (LSB)									   |  */
/*	+----+--+--+--+--------------------------------------------------------+  */
/*  |  1 | L| L| H|	Divisor latch (MSB)									   |  */
/*	+----+--+--+--+--------------------------------------------------------+  */
/*  |  X | L| H| L|	Interrupt identification register (read only)		   |  */
/*	+----+--+--+--+--------------------------------------------------------+  */
/*  |  X | L| H| L|	FIFO control register (write)						   |  */
/*	+----+--+--+--+--------------------------------------------------------+  */
/*  |  X | L| H| H|	Line control register								   |  */
/*	+----+--+--+--+--------------------------------------------------------+  */
/*  |  X | H| L| L|	Modem control register								   |  */
/*	+----+--+--+--+--------------------------------------------------------+  */
/*  |  X | H| L| H|	Line status register								   |  */
/*	+----+--+--+--+--------------------------------------------------------+  */
/*  |  X | H| H| L|	Modem status register								   |  */
/*	+----+--+--+--+--------------------------------------------------------+  */
/*  |  X | H| H| h|	Scratch register									   |  */
/*	+----+--+--+--+--------------------------------------------------------+  */
/******************************************************************************/
void Uart_Init(void);
unsigned int Uart_tx(unsigned int data);
unsigned int Uart_rx(void);
