/******************************************************************************/
/* CPU_REG.h                                                                  */
/*                                                                            */
/* This is proprietary information, not to be published -- DIGIPRO DATA   	  */
/* Copyright (C) 2002, DigiPro Information Co.,Ltd.  All Rights Reserved.     */
/*                                                                            */
/* Author: Wu DingMing                                                        */
/* Date: August 12, 2002                                                      */
/******************************************************************************/ 
/******************************************************************************/
/* 			Interrupt Flag Register(IFR)Bits								  */
/******************************************************************************/
/* +-0f--0e-+--0d-+--0c-+--0b--------+--0a--------+-09-+-08-+			  	  */
/* | RES    |DMAC5|DMAC4|BXINT1/DMAC3|BRINT1/DMAC2|HINT|INT3|				  */
/* +--------+-----+-----+------------+------------+----+----+		          */
/* +--07--------+--06--------+--05--+--04--+-03-+-02-+-01-+-00-+			  */                   
/* |BXINT2/DMAC1|BRINT2/DMAC0|BXINT0|BRINT0|TINT|INT2|INT1|INT0|			  */
/* +------------+------------+------+------+----+----+----+----+	          */
/******************************************************************************/

/******************************************************************************/
/* 			Interrupt Mask Register(IMR)Bits								  */
/******************************************************************************/
/* +-0f--0e-+--0d-+--0c-+--0b--------+--0a--------+-09-+-08-+			  	  */
/* | RES    |DMAC5|DMAC4|BXINT1/DMAC3|BRINT1/DMAC2|HINT|INT3|				  */
/* +--------+-----+-----+------------+------------+----+----+		          */
/* +--07--------+--06--------+--05--+--04--+-03-+-02-+-01-+-00-+			  */                   
/* |BXINT2/DMAC1|BRINT2/DMAC0|BXINT0|BRINT0|TINT|INT2|INT1|INT0|			  */
/* +------------+------------+------+------+----+----+----+----+	          */
/******************************************************************************/

/******************************************************************************/
/*			Processor Mode Status Register(PMST)Bits						  */
/******************************************************************************/
/* +-0f--07-+--06--+-05-+-04-+-03-+--02--+-01-+-00--+						  */
/* |  IPTR  |MP/_MC|OVLY|AVIS|DROM|CLKOFF|SMUL| SST |                         */
/* +--------+------+----+----+----+------+----+-----+						  */
/******************************************************************************/

/******************************************************************************/
/*			Status Register 0(ST0)Bits										  */
/******************************************************************************/
/* +-0f-0d-+-0c-+-0b--+-0a--+-09--+--08--00--+								  */
/* |  ARP  | TC |  C  | OVA | OVB |    DP    |                                */
/* +-------+----+-----+-----+-----+----------+								  */
/******************************************************************************/

/******************************************************************************/
/*			Status Register 1(ST1)Bits										  */
/******************************************************************************/
/* +-0f-+-0e--+-0d-+-0c-+-0b-+-0a-+-09--+-08--+-07--+-06-+-05-+-04-00-+		  */
/* |BRAF| CPL | XF | HM |INTM| 00 | OVM | SXM | C16 |FRST|CMPT|   ASM |		  */
/* +----+-----+----+----+----+----+-----+-----+-----+----+----+-------+		  */
/******************************************************************************/

/******************************************************************************/
/*	CLKMD Registers BIT                                       				  */
/******************************************************************************/                                                                                
/* +-0f--0C-+--0B--+-0A--03-+---02----+--01---+----00---+					  */
/* | PLLMUL |PLLDIV|PLLCOUNT|PLLON/OFF|PLLNDIV|PLLSTATUS|                     */
/* +--------+------+--------+---------+-------+---------+					  */
/******************************************************************************/
#define PLLMUL    0xF000
#define PLLDIV    0x0800
#define PLLCNT    0x07F8
#define PLLOFF    0x0004
#define PLLNDIV   0x0002
#define PLLSTAT   0x0001
#define PLL_DIV_INIT         0x6004
#define PLL_LOCK_INIT_X(X)   (0x07fb | ((((X)-1)&0xf)<<12))
